/*																			*/
/* FONT8x8.C -- routines for using the 43/50-line mode provided by the		*/
/*				ROM 8x8 font on EGA and VGA									*/
/*																			*/
/*				Written 1989 by Peter Anvin									*/
/*																			*/

#include <conio.h>
#include <dos.h>

int setfont8x8(int mode)
	/* Uses the EGA/VGA 8x8 font to display 43/50 lines text display.		*/
	/* MCGA works in this case like a VGA.                           		*/
{
	int maxlines, maxcol;
	char vtype;

	textmode(mode);	/* Set text mode. This will reset to a known state.		*/

	_AH = 0x0F;						/* Check current display width (40/80)	*/
	geninterrupt(0x10);

	maxcol = _AH;

					/* Look for VGA or PS/2. If no VGA or PS/2, check EGA.	*/

	_AX = 0x1A00;
	geninterrupt(0x10);

	vtype = _BL;

	if ( _AL == 0x1A )				/* VGA or PS/2 present? Check video ID	*/
	{

		switch( vtype )
		{
			case 4 :
			case 5 :
						maxlines = 43;					/* EGA running		*/
						break;
			case 7 :
			case 8 :
			case 11 :
			case 12 :
						maxlines = 50;					/* VGA/MCGA 		*/
						break;
			default :
						maxlines = 25;					/* Something else	*/
						break;
			}
	}
	else							/* OK then... look for EGA				*/
	{
		_AH = 0x12;					/* Does not exist in CGA/MDA			*/
		_BL = 0x10;
		geninterrupt(0x10);

		if ( _BL == 0x10 )
		{
			maxlines = 25;						/* No EGA BIOS present		*/
		}
		else
		{
			maxlines = 43;						/* EGA BIOS & card present	*/
		}
	}

	if ( maxlines > 25 )
	{
		_AX = 0x1112;				/* Set font 8x8, change screen length	*/
		_BL = 0;
		geninterrupt(0x10);

		_AX = 0x1103;									/* Use font 8x8		*/
		_BL = 0;
		geninterrupt(0x10);


	}

	*( (char *) &directvideo - 8 ) = maxlines;		/* Set max no of lines	*/
	window(1,1,maxcol,maxlines);

	return(maxlines);
}


void setstdfont(int mode)
	/* Reset 80x25 mode by forcing a call to BIOS change mode				*/
{
	if ( mode != LASTMODE )
	{
		_AL = mode;
	}
	else
	{
		_AH = 0x0F;							/* What mode are we in now??	*/
		geninterrupt(0x10);
		mode = _AL;
	}

	_AH = 0;
	geninterrupt(0x10);

	*( (char *) &directvideo - 8 ) = 25;	/* Reset max number of lines	*/

	textmode(mode);             	/* Update Turbo C's variables			*/
}



