#include <dos.h>
#include <stdarg.h>
#include <stdlib.h>

#define mouseint() geninterrupt(0x33)		/* Converts to an INT 33H instr. */

#if defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
#define LARGEDATA		1
#endif

int resetmouse(void)
/* This function resets the mouse device driver to standard zero state
   - call to initialize
   Return value:
		0 		.. no mouse (or no driver)
		>0		.. number of buttons
*/
{

	_AX = 0;

	mouseint();

	return( _AX & _BX );

}

void mouseon(void)
/* Increases the mouse cursor counter. If zero, display. (Initially = -1) */
{

	_AX = 1;

	mouseint();

}

void mouseoff(void)
/* Decreases the mouse cursor counter */
{

	_AX = 2;

	mouseint();

}

int mouse(int *xpos, int *ypos)
/* Returns the current status of the mouse. Pixel coordinates are returned in
   xpos and ypos (conversion will be needed). The return value contains
   left button in bit 0 and right in bit 1 */
{
	int x, y, stat;

	_AX = 3;

	mouseint();

	x = _CX;
	y = _DX;
	stat = _BX;

	if ( xpos != NULL )
		*xpos = x;

	if ( ypos != NULL )
		*ypos = y;

	return(stat);
}

