#include <string.h>
#include <stdlib.h>


char *seekswitch(int *argc, char *argv[])
	/* Seeks in all command-line input for switches (case insensitive)		*/
	/* Returns a static buffer containing all switch chars (chars following	*/
	/* a slash (/))	in upper case											*/
	/*																		*/
	/* The function also deletes the switches from the command-line buffer	*/

{
	int i, j;
	static char found[63];
	char *scn, *efound, ch;

	efound = found;
	*efound = '\0';

	for ( i = 1 ; i < *argc ; i++ )
	{
		scn = argv[i];

		while ( *scn )
		{
			if ( *(scn++) == '/' )
			{
				ch = *(scn--);

				strcpy(scn,scn+2);

				if ( ch >= 'a' && ch <='z' )
					ch -= 32;

				if ( strchr(found,ch) == NULL )
				{
					*(efound++) = ch;
					*efound = '\0';
				}

				if ( strlen(argv[i]) == 0 )
				{
					(*argc)--;

					for ( j = i ; j < *argc ; j++ )
					{
						argv[j] = argv[j+1];
					}

					argv[*argc] = NULL;

					scn = argv[i];
				}
			}
		}
	}

	return(found);
}

