#pragma inline

/*
/* TONE.C	--- tone() function makes it easier/quicker to create music		*/
/*				than with sound()											*/
/*																			*/

#include <dos.h>

void toneon(unsigned toneno)
{
	static unsigned dividers[] =
		{
			43381U, 40947U, 38649U, 36480U, 34432U, 32500U,
			30676U, 28954U, 27329U, 25795U, 24347U, 22981U
		};

	/* The divider table contains timer divider numbers from A0 to G#1		*/


	if ( toneno < 120 )			/* 120 = A10 is a 28 kHz tone				*/
	{
		asm mov ax,toneno;
		asm mov bl,12;			/* Let BL contain the quotient				*/
		asm div bl;
								/* NOW: AL = octave shift, AH = tone		*/
		asm mov cl,al;			/* Store shift in CL						*/
		asm xor bx,bx;
		asm mov bl,ah;			/* Store tone in BX							*/
		asm shl bx,1;			/* Convert BX to a word address				*/

		asm mov dx,dividers[bx];	/* Get the tone code					*/
		asm clc;				/* Clear carry								*/
		asm shr dx,cl;			/* Shift it if necessary					*/

		asm jnc no_carry;		/* If carry: round up; no carry: OK			*/
		asm inc dx;
no_carry:

		asm	mov al,0F5h;		/* Write 8253 port 2 command				*/
		asm out 43h,al;
		asm mov al,dl;			/* Now write LSB							*/
		asm out 42h,al;			/* Port 2 I/O address						*/
		asm mov al,dh;			/* Follow by MSB							*/
		asm out 42h,al;

		asm in al,61h;			/* System control/status port B				*/
		asm or al,3;			/* Enable speaker							*/
		asm out 61h,al;
	}
}


void toneoff(void)
{
    asm in al,61h;
    asm and al,0FEh;
    asm out 61h,al;
}


void tone(unsigned toneno, unsigned duration)
{
	toneon(toneno);

	delay(duration);

	toneoff();
}


